# This is a sample Python script.

# Press Shift+F10 to execute it or replace it with your code.
# Press Double Shift to search everywhere for classes, files, tool windows, actions, and settings.
import numpy as np
import h5py
import cv2 as cv
import os
import torch.nn as nn
import torchvision.models as models
from torchvision import transforms
from PIL import Image
import torch
from torch.utils.data import TensorDataset, DataLoader, default_collate
from torch.optim import Adam
from torch.autograd import Variable


##### GPU Related Functions #####
device = torch.device('cuda' if torch.cuda.is_available() else 'cpu')
torch.cuda.empty_cache()
# print(torch.cuda.memory_summary(device=device, abbreviated=False))

#### Function to create a random image #####
def create_random_image(H, W):
    array = np.random.rand(H, W, 3) * 255  # random noise
    array = array.astype(np.uint8)
    # img = cv.cvtColor(array, cv.COLOR_BGR2RGB)
    img = Image.fromarray(array, 'RGB')
    return img

# Define your preprocessing pipeline
preprocess = transforms.Compose([
    transforms.Resize((224, 224)),  # Resize the input PIL Image to the given size.
    transforms.ToTensor(),  # Convert the PIL Image to a tensor.
    transforms.Normalize(mean=[0.485, 0.456, 0.406], std=[0.229, 0.224, 0.225]),  # Normalize the tensor image for feeding to Resnet
])

########## MinMax Normalize of Resnet Results #####
def min_max_normalize(tensor):
    sorted_tensor, _ = torch.sort(tensor)
    min_val = sorted_tensor[9]  # 10th smallest value
    max_val = sorted_tensor[-10]  # 10th largest value
    # min_val = torch.min(tensor)
    # max_val = torch.max(tensor)
    normalized_tensor = (tensor - min_val) / (max_val - min_val)
    return normalized_tensor

f = h5py.File("val_on.h5", 'r')
print(f.keys())

scenes = f['scene']
objview = f['objView']

challenge_objs= f['challenge_objs']
challenge_scene = f['challenge_scene']
query_challenges_list = f['query_challenges_list']
query_list = f['query_list']
query_target_list = f['query_target_list']

##### Check different keys' values ####
# arr = (np.array(challenge_scene))
# indices_of_changes = np.where(np.diff(arr) != 0)[0] + 1
#
# print("Indices of changes:", indices_of_changes)
# print(indices_of_changes.shape)

# print(f'query_list_shape: {query_list.shape}')
# print(f'query: {query_list[1]}')

# print(f'query_challenge_list_shape: {query_challenges_list.shape}')
# print(f'corresponding challenge: {query_challenges_list[1]}')

# print(f'label_shape: {query_target_list.shape}')
# print(f'label: {type(query_target_list[0][0])}') # It is important notation

# print(f'challenge_shape: {challenge_objs.shape}')
# print(f'challenge : {(challenge_objs[1][0][1])}') # It is important notation

# print(f'challenge_scene_shape: {challenge_scene.shape}')
# print(f'challenge scene: {challenge_scene[6]}')
#
# print(str(challenge_objs[0])[4])
# print(challenge_objs[0][0][1])


#### Create an array of random images ####
# scenes_img = [create_random_image(320, 480) for _ in range(len(scenes))]
# objs_img = [create_random_image(32, 32) for _ in range(10)]

##### Testing for 1 scene Image & 1 obj view####
# first_scene = scenes[0] # It returns numpy array
# # scenes_img[0] = Image.fromarray((first_scene * 255).astype(np.uint8)) # It returns PIL Image
# rgb_first_scene = first_scene[:, :, ::-1]
# scenes_img[0] = Image.fromarray((rgb_first_scene * 255).astype(np.uint8))
# print(type(scenes_img[0]))
# # cv.imshow('image', scenes_img[0])
# # cv.waitKey(5000)
# scenes_img[0].show()
# # #if key == 27:#if ESC is pressed, exit loop
# # #cv2.destroyAllWindows()

# first_obj = objview[6][2]
# rgb_first_obj = first_obj[:, :, ::-1]
# objs_img[0] = Image.fromarray((rgb_first_obj * 255).astype(np.uint8))
# print(type(objs_img[0]))
# objs_img[0].show()


#### Having Scene images as PIL images ####
# for i in range(len(scenes)):
#     bgr_scene = scenes[i]
#     rgb_scene = bgr_scene[:, :, ::-1]
#     scenes_img[i] = Image.fromarray((rgb_scene * 255).astype(np.uint8))

#### Having Obj images as PIL images ####
# for i in range(10):
#     bgr_obj = objview[i][0]
#     rgb_obj = bgr_obj[:, :, ::-1]
#     objs_img[i] = Image.fromarray((rgb_obj * 255).astype(np.uint8))


# scenes_tensors = [] # Empty list for preprocessed tensors
#### preprocess scene images and having them as tensors####
# for i in range(len(scenes_img)):
#     temp_tensor = preprocess(scenes_img[i])
#     # print(type(temp_tensor))
#     scenes_tensors.append(temp_tensor)
#
# scenes_st = torch.stack(scenes_tensors) # Putting tensors in a batch

# obj_tensors = []
# #### preprocess obj images and having them as tensors####
# for i in range(10):
#     temp_tensor = preprocess(objs_img[i])
#     # print(type(temp_tensor))
#     obj_tensors.append(temp_tensor)
#
# objs_st = torch.stack(obj_tensors) # Putting tensors in a batch

##### Resnet ####
# resnet152 = models.resnet152(pretrained=True)
# modules=list(resnet152.children())[:-1]
# resnet152= nn.Sequential(*modules)
# for p in resnet152.parameters():
#     p.requires_grad = False
#
# resnet152 = resnet152.to(device)

#### Extracting the Scene Features #### & Saving them
# scenes_st = Variable(scenes_st)
# scenes_st = scenes_st.to(device)
#
# scenes_F = resnet152(scenes_st)
# print(f'scene features shape is', {scenes_F.shape})
# torch.save(scenes_F.cpu(), 'VSceneFeatures.pt')

#### Extracting the obj Features #### & Saving them
# objs_st = Variable(objs_st)
# objs_st = objs_st.to(device)
#
# objs_F = resnet152(objs_st)
# print(f'obj features shape is', {objs_F.shape})
# torch.save(objs_F.cpu(), 'VObjFeatures.pt')

#### Loading Scene & Obj features and min_max normalize them ####
# obj_F = torch.load('VObjFeatures.pt').to(device)
# scene_F = torch.load('VSceneFeatures.pt').to(device)
#
#
# obj_F = obj_F.view(10,2048).to(device)
# scene_F = scene_F.view(1600, 2048).to(device)
#
# # print(obj_F.shape)
# # print(scene_F.shape)
#
# for i in range(len(obj_F)):
#     obj_F[i] = min_max_normalize(obj_F[i])
#
# for i in range(len(scene_F)):
#     scene_F[i] = min_max_normalize(scene_F[i])
#     if (i % 100 == 0):
#         print(f'scene {i} got normalized')
#
# torch.save(scene_F.cpu(), 'NVScene_F.pt')
# torch.save(obj_F.cpu(), 'NVObj_F.pt')

#### Loading Normalized Scene & Obj Features ####
# scene_F = torch.load('NVScene_F.pt').to(device)
# obj_F = torch.load('NVObj_F.pt').to(device)
# print(scene_F.shape)
# print(obj_F.shape)

### Construct A Sample from Features ####
# Sample = torch.cat((obj_F[0], scene_F[0]))
# Sample = torch.cat((Sample, obj_F[0], obj_F[5]))
# Sample = Sample.unsqueeze(0)
# print(Sample.shape)

#### Construct Input data from loaded Features and Save them ####
# for i in range(1, 120000):
#     query_id = query_list[i]
#     # print(f'query is {query_id}')
#     temp_sample = obj_F[query_id]
#     # print(f'obj tensor shape: {temp_sample.shape}')
#
#     ch_id = query_challenges_list[i]
#     # print(f'challenge id is: {ch_id}')
#     scene_id = challenge_scene[ch_id]
#     # print(f'scene is: {scene_id}')
#     temp_sample1 = torch.cat((temp_sample, scene_F[scene_id]))
#
#     predicate_1 = challenge_objs[ch_id][0][0]
#     # print(f'p1 is: {predicate_1}')
#     predicate_2 = challenge_objs[ch_id][0][1]
#     # print(f'p2 is: {predicate_2}')
#     temp_sample2 = torch.cat((temp_sample1, obj_F[predicate_1], obj_F[predicate_2]))
#     Sample = torch.vstack((Sample, temp_sample2))
#
#     if (i % 500 == 0):
#         print(f'Sample shape: {Sample.shape}')
#
# torch.save(Sample.cpu(), 'NVInput_OnVal.pt')

#### Construct Labels and Save them####
# a = np.array(query_target_list)
# print(type(a[10][0]))
# LabelSample =

#LSample = torch.from_numpy(np.array(query_target_list))
# # # LSample = LSample.unsqueeze(0)
#LSample = LSample.float()
#print(f'LSample shape: {LSample.shape}')
# print((LSample[:10]))
#torch.save(LSample, 'NVLabel_OnVal.pt')


### Loading the Input data and Labels ####
# Input_data = torch.load('NVInput_OnVal.pt')
# Input_label = torch.load('NVLabel_OnVal.pt')
# #print(f'actual label ex: {Input_label[100:105]}')
# print(f'Input shape:{Input_data.shape},label: {Input_label.shape}')
# #
#
# #### Shuffle dataset & save splitted sets ####
# samples_np = Input_data.detach().cpu().numpy()
# print(f'numpy samples shape: {samples_np.shape}')
# labels_np = Input_label.detach().cpu().numpy().ravel()
# print(f'numpy label shape: {labels_np.shape}')
#
# indices = np.arange(samples_np.shape[0])
# np.random.shuffle(indices)
# # #
# X_np_shuffled = samples_np[indices]
# y_np_shuffled = labels_np[indices]
# # #
# print(f'Shuffled data shape: {X_np_shuffled.shape}, {y_np_shuffled.shape}')
# # #
# # #
# Shuffled_sample = torch.from_numpy(X_np_shuffled)
# Shuffled_label = torch.from_numpy(y_np_shuffled)
# Shuffled_label = Shuffled_label.unsqueeze(1)
#
# # #
# print(f'Shuffled tensor shape: {Shuffled_sample.shape}, {Shuffled_label.shape}')
# #print(f'label tensor example: {balanced_label[100:105]}')
#
# train_sample = Shuffled_sample[:int(len(Shuffled_sample) * 0.7)]
# train_label = Shuffled_label[:int(len(Shuffled_sample) * 0.7)]
# # print(f'train shape: {train_sample.shape}')
# test_sample = Shuffled_sample[int(len(Shuffled_sample) * 0.7):]
# test_label = Shuffled_label[int(len(Shuffled_sample) * 0.7):]
# # print(f'test shape: {test_sample.shape}')
#
# torch.save(train_sample, 'OnTrainInputV1.pt')
# torch.save(test_sample, 'OnTestInputV1.pt')
#
# torch.save(train_label, 'OnTrainLabelV1.pt')
# torch.save(test_label, 'OnTestLabelV1.pt')


#### Make a balanced dataset ####
# samples_np = Input_data.detach().cpu().numpy()
# print(f'numpy samples shape: {samples_np.shape}')
# labels_np = Input_label.detach().cpu().numpy().ravel()
# print(f'numpy label shape: {labels_np.shape}')
# # #
# true_sample = samples_np[labels_np == True]
# false_sample = samples_np[labels_np == False]
# # #
# #print(f'true sample shape: {true_sample.shape}')
# # #
# true_label = labels_np[labels_np == True]
# false_label = labels_np[labels_np == False]
# # #
# #print(f'true label shape: {true_label.shape}')
# # #
# a = 3000
# # #
# xt = true_sample[:a]
# lt = true_label[:a]
# #print(f'True Label example: {lt[100:105]}')
# # #
# xf = false_sample[:a]
# lf = false_label[:a]
# #print(f'Negative Label example: {lf[100:105]}')
#
# # #
# x = np.concatenate([xt,xf])
# l = np.concatenate([lt,lf])
# # #
# #print(f'balanced data shape: {x.shape}, {l.shape}')
# # #
# # #
# indices = np.arange(x.shape[0])
# np.random.shuffle(indices)
# # #
# X_np_shuffled = x[indices]
# y_np_shuffled = l[indices]
# # #
# #print(f'Shuffled data shape: {X_np_shuffled.shape}, {y_np_shuffled.shape}')
# # #
# # #
# balanced_sample = torch.from_numpy(X_np_shuffled)
# balanced_label = torch.from_numpy(y_np_shuffled)
# balanced_label = balanced_label.unsqueeze(1)
#
# # #
# print(f'balanced tensor shape: {balanced_sample.shape}, {balanced_label.shape}')
# #print(f'label tensor example: {balanced_label[100:105]}')


#### Load Datasets ####
TrainSample = torch.load('OnTrainInputV1.pt')
TrainLabel = torch.load('OnTrainLabelV1.pt')
print(TrainSample.shape)
TestSample = torch.load('OnTestInputV1.pt')
TestLabel = torch.load('OnTestLabelV1.pt')
print(TestLabel.shape)

#### Define NNs ####
class NodeExtractor(nn.Module):
    def __init__(self, input_dim, output_dim):
        super(NodeExtractor, self).__init__()

        # hidden_sizes = [2048, 1024, 512]
        hidden_sizes = [2048]
        # Create the first layer
        layers = [nn.Linear(input_dim, hidden_sizes[0]), nn.ReLU()]

        # Create the hidden layers
        # for i in range(3 - 1): # 4 is the size of the hidden_sizes list
        #     layers.append(nn.Linear(hidden_sizes[i], hidden_sizes[i + 1]))
        #     layers.append(nn.ReLU())

        # Create the output layer

        # layers.append(nn.Linear(hidden_sizes[0], 2048))
        # layers.append(nn.ReLU())

        layers.append(nn.Linear(hidden_sizes[0], output_dim))
        layers.append(nn.ReLU())
        # layers.append(nn.ReLU())
        # layers.append(nn.Dropout(p=0.5))
        # Store the layers in the model
        self.layers = nn.Sequential(*layers)

    def forward(self, x):
        return self.layers(x)

class MyNetwork1(nn.Module):
    def __init__(self, input_dim, output_dim):
        super(MyNetwork1, self).__init__()

        # hidden_sizes = [2048, 1024, 512]
        hidden_sizes = [4096]
        # Create the first layer
        layers = [nn.Linear(input_dim, hidden_sizes[0]), nn.ReLU()]

        # Create the hidden layers
        # for i in range(3 - 1): # 4 is the size of the hidden_sizes list
        #     layers.append(nn.Linear(hidden_sizes[i], hidden_sizes[i + 1]))
        #     layers.append(nn.ReLU())

        # Create the output layer

        layers.append(nn.Linear(hidden_sizes[0], 2048))
        layers.append(nn.ReLU())

        layers.append(nn.Linear(2048, output_dim))
        # layers.append(nn.ReLU())
        # layers.append(nn.Dropout(p=0.5))
        # Store the layers in the model
        self.layers = nn.Sequential(*layers)

    def forward(self, x):
        return self.layers(x)


PredicateNet = MyNetwork1(8192, 1).to(device)

# Initialize the optimizer
optimizer = Adam(PredicateNet.parameters(), lr=0.01)
#
# Choose a batch size and Inputs, Labels
batch_size = 128
input = TrainSample
label = TrainLabel
#print(input.shape)
#print(label.shape)

num_positives = label.sum().item()
num_negatives = label.numel() - num_positives

print("Number of positive samples:", num_positives)
print("Number of negative samples:", num_negatives)

pos_weight = torch.tensor([num_negatives / num_positives]).to(device)

dataset = TensorDataset(input, label)
dataloader = DataLoader(dataset, batch_size=batch_size, shuffle=True)
testset = TensorDataset(TestSample, TestLabel)
X_test, y_test = default_collate(testset)
X_test = X_test.to(device)
y_test = y_test.to(device
                   )

# Initializing the Criterion
criterion = nn.BCEWithLogitsLoss(pos_weight= pos_weight)
#
for epoch in range(200):
    PredicateNet.train()
    for X_batch, y_batch in dataloader:
        X_batch = X_batch.to(device)
        y_batch = y_batch.to(device)
        y_pred = PredicateNet(X_batch)
        loss = criterion(y_pred, y_batch)
        optimizer.zero_grad()
        loss.backward()
        optimizer.step()
    PredicateNet.eval()
    y_pred = PredicateNet(X_test)
    acc = (y_pred.round() == y_test).float().mean()
    print(f"End of epoch {epoch}: accuracy = {float(acc)*100:.2f}%")
# # Training loop
# print('Training Starts')
# for i in range(200):  # Modify to fit your problem
#     for batch_samples, batch_labels in dataloader:
# #        torch.cuda.empty_cache()
#         optimizer.zero_grad()
#
#         Input = batch_samples.to(device)
#         target_labels = batch_labels.to(device)
#
#         # Forward pass through NN1 and NN2
#         # NodeE = NExtractNet(NInput)
#         # EdgeE = EExtractNet(EInput)
#
#         # Concatenate outputs and pass through NN3
#         Predict_Label = PredicateNet(Input)
#
#         loss = criterion(Predict_Label, target_labels)
#
#         # Backward pass and optimization
#         loss.backward()
#         optimizer.step()
#
#     if i % 10 == 0:
#          print(f'Iteration {i}, Loss: {loss.item()}')
#
# print('Training finished')
#
# #### Getting Accuracy ####
# total = 3000
# correct = 0
# torch.cuda.empty_cache()
#
# NInput = Input_data[10000:13000].to(device)
# target_labels = Input_label[10000:13000].to(device)
#
# Predict_Label = PredicateNet(NInput)
# predicted = (torch.sigmoid(Predict_Label) > 0.5).float()
#
# num_positive_predicts = predicted.sum().item()
# print("Number of positive predictions:", num_positive_predicts)
#
#
# correct += (predicted == target_labels).sum().item()
# print('Accuracy of the network on the train images: %d %%' % (100 * correct / total))

# # Define your neural networks
# # class Network(nn.Module):
# #     def __init__(self, input_dim, hidden_dim, output_dim):
# #         super(Network, self).__init__()
# #         self.layer = nn.Sequential(
# #             nn.Linear(input_dim, hidden_dim),
# #             nn.ReLU(),
# #             nn.Linear(hidden_dim, output_dim),
# #         )
# #
# #     def forward(self, x):
# #         return self.layer(x)
# #


# class MyNetwork(nn.Module):
#     def __init__(self, input_dim, output_dim, num_layers):
#         super(MyNetwork, self).__init__()
#
#         # Compute a list of sizes for the hidden layers
#         hidden_sizes = [int(input_dim * ((output_dim / input_dim) ** (i / num_layers))) for i in range(1, num_layers)]
#
#         # Create the first layer
#         layers = [nn.Linear(input_dim, hidden_sizes[0]), nn.ReLU()]
#
#         # Create the hidden layers
#         for i in range(num_layers - 2):
#             layers.append(nn.Linear(hidden_sizes[i], hidden_sizes[i + 1]))
#             layers.append(nn.ReLU())
#
#         # Create the output layer
#         layers.append(nn.Linear(hidden_sizes[-1], output_dim))
#
#         # Store the layers in the model
#         self.layers = nn.Sequential(*layers)
#
#     def forward(self, x):
#         return self.layers(x)
#
#
# # node embedding extractor network
# NExtract_in = 4096
# NExtract_out = 128
# NExtract_layerNum = 50
#
# NExtractNet = MyNetwork(NExtract_in, NExtract_out, NExtract_layerNum).to(device)
#
# # node embedding extractor network
# EExtract_in = 6144
# EExtract_out = 128
# EExtract_layerNum = 50
#
# EExtractNet = MyNetwork(EExtract_in, EExtract_out, EExtract_layerNum).to(device)
#
# PredicateNet_in = 256
# PredicateNet_out = 1
# PredicateNet_layerNum = 50
# PredicateNet = MyNetwork(PredicateNet_in, PredicateNet_out, PredicateNet_layerNum).to(device)
#
# # Assuming 'samples' and 'labels' are your tensors
# # samples = Input_data  # replace with your actual tensor
# # labels = Input_label  # also replace with your actual tensor
# #

# #
# # NInput = balanced_sample[:, :4096].to(device)
# # EInput = balanced_sample[:, 2048:].to(device)
# # target_labels = balanced_label.to(device)
# # target_labels = target_labels.unsqueeze(1)
# # print(f'target label shape: {target_labels.shape}')
#
# # num_positives = target_labels.sum().item()
# # num_negatives = target_labels.numel() - num_positives
#
# # print("Number of positive samples:", num_positives)
# # print("Number of negative samples:", num_negatives)
# # print(f'Number of all samples: {target_labels.size(0)}')
# # Initialize your optimizer
# optimizer = Adam(list(NExtractNet.parameters()) + list(EExtractNet.parameters()) + list(PredicateNet.parameters()), lr=0.01)
#
# # # Training loop
# # for i in range(200):  # Modify to fit your problem
# #     torch.cuda.empty_cache()
# #     optimizer.zero_grad()
# #
# #     # Forward pass through NN1 and NN2
# #     NodeE = NExtractNet(NInput)
# #     EdgeE = EExtractNet(EInput)
# #
# #     # Concatenate outputs and pass through NN3
# #     Predict_Label = PredicateNet(torch.cat((NodeE, EdgeE), dim=1))
# #     # print(Predict_Label.shape)
# #
# #     # Compute loss
# #     # pos_weight = torch.tensor([num_positives / num_negatives]).to(device)
# #     criterion = nn.BCEWithLogitsLoss()
# #     loss = criterion(Predict_Label, target_labels)
# #
# #     # Backward pass and optimization
# #     loss.backward()
# #     optimizer.step()
# #
# #
# #     if i % 25 == 0:
# #         print(f'Iteration {i}, Loss: {loss.item()}')
#
# # # Choose a batch size
# # batch_size = 256
# #
# # # Create a TensorDataset and DataLoader
# # dataset = TensorDataset(samples[:7500], labels[:7500])
# # dataloader = DataLoader(dataset, batch_size=batch_size, shuffle=True)
# #
# # # Initialize your optimizer
# optimizer = Adam(list(NExtractNet.parameters()) + list(EExtractNet.parameters()) + list(PredicateNet.parameters()), lr=0.001)
#
# # Training loop
# # for i in range(1000):  # Modify to fit your problem
# #     for batch_samples, batch_labels in dataloader:
# #         torch.cuda.empty_cache()
# #         optimizer.zero_grad()
# #
# #         # Move data and labels to device
# #         NInput = batch_samples[:, :4096].to(device)
# #         EInput = batch_samples[:, 2048:].to(device)
# #         target_labels = batch_labels.to(device)
# #
# #         # Forward pass through NN1 and NN2
# #         NodeE = NExtractNet(NInput)
# #         EdgeE = EExtractNet(EInput)
# #
# #         # Concatenate outputs and pass through NN3
# #         Predict_Label = PredicateNet(torch.cat((NodeE, EdgeE), dim=1))
# #
# #         # Compute loss
# #         num_positives = target_labels.sum().item()
# #         num_negatives = target_labels.numel() - num_positives
# #         pos_weight = torch.tensor([num_negatives / num_positives]).to(device)
# #         criterion = nn.BCEWithLogitsLoss(pos_weight = pos_weight)
# #         loss = criterion(Predict_Label, target_labels)
# #
# #         # Backward pass and optimization
# #         loss.backward()
# #         optimizer.step()
# #
# #     # Print CUDA memory summary after each epoch
# #     # print(torch.cuda.memory_summary(device=device, abbreviated=False))
# #     # print("Number of positive samples:", num_positives)
# #     # print("Number of negative samples:", num_negatives)
# #     # print(f'Number of all samples: {target_labels.size(0)}')
# #     if i % 100 == 0:
# #          print(f'Iteration {i}, Loss: {loss.item()}')
# # # #
# # # #
# # print('Training finished')
# # total = 0
# # correct = 0
# # torch.cuda.empty_cache()
# #
# # # NInput = samples[:7500, :4096].to(device)
# # # EInput = samples[:7500, 2048:].to(device)
# # # EdgeE = EExtractNet(EInput)
# # # NodeE = NExtractNet(NInput)
# # # target_labels = labels[:7500].to(device)
# # # # Concatenate outputs and pass through NN3
# #
# # NInput = balanced_sample[:, :4096].to(device)
# # EInput = balanced_sample[:, 2048:].to(device)
# # target_labels = balanced_label.to(device)
# # target_labels = target_labels.unsqueeze(1)
# #
# # EdgeE = EExtractNet(EInput)
# # NodeE = NExtractNet(NInput)
# Predict_Label = PredicateNet(torch.cat((NodeE, EdgeE), dim=1))
#
# predicted = (torch.sigmoid(Predict_Label) > 0.5).float()
# # total += target_labels.size(0)
# # correct += (predicted == target_labels).sum().item()
# #
# # print('Accuracy of the network on the train images: %d %%' % (100 * correct / total))
#
# # for i in range(len(Input_label)):
# #     if i % 100
# #     print(predicted[i])
# # See PyCharm help at https://www.jetbrains.com/help/pycharm/
